<?php
Cavy::loadClass('Cavy_Audit');
class NpaiSettingController extends Cavy_Controller_Action {
	public $models = 'npaiSetting';

	public function index(){
		$info = $this->NpaiSetting->getNpaiSettingInfo();
		$this->_render(array('info' => $info));
	}
	
	public function espcNpaiConfig() {
		$info = $this->NpaiSetting->getNpaiSettingInfo();
		$this->_render(array('info' => $info));
	}
	
	public function esppNpaiConfig() {
		$info = $this->NpaiSetting->getNpaiSettingInfo();
		$this->_render(array('info' => $info));
	}
	
	public function update(){
		if($this->_hasError()) {
			$this->_render(array(), 'result');
		}else{
			$this->NpaiSetting->updateNpaiSetting($this->_params['setting']);
			Cavy_Audit::newoperationLog('audit.setting.update');
			$info ='setting.form.submit.certain';
			$this->_render(array('info' => $info), 'result');
		}
	}
	
	public function getStatus(){
		$status = $this->NpaiSetting->getNpaiStatus();
		echo json_encode($status);
	}
	
	public function recoverSetting(){
		$msg = $this->NpaiSetting->recoverSetting();
		Cavy_Audit::newoperationLog('audit.setting.recover');
		echo $msg;
	}
	
	public function recoverEspcSetting(){
		$msg = $this->NpaiSetting->recoverEspcSetting();
		Cavy_Audit::newoperationLog('audit.setting.espc.npai.recover');
		echo $msg;
	}
	
	public function manageEsppUseStatus() {
		if($this->_params['operate'] == "turnOff") {
			Cavy_Audit::newoperationLog('audit.setting.espp.notuse');
			echo $this->NpaiSetting->manageEsppUse(False);
		} else if($this->_params['operate'] == "turnOn") {
			Cavy_Audit::newoperationLog('audit.setting.espp.use');
			echo $this->NpaiSetting->manageEsppUse(True);
		}
	}
	
	public function validateOnUpdate($validator) {
		$params = $this->_params['setting'];
		$parentAddresses = array();
		// validate base config
		//localeIp
		$params['local_ip'] = trim($params['local_ip']);
		if(!$this->is_ip($params['local_ip'])) {
			$validator->addFieldError('local_ip', $this->getText('setting.form.error.local.ip'));
		}
		//espp
		$params['espp_ip'] = trim($params['espp_ip']);
		if(!$this->is_ip($params['espp_ip']) && !$this->is_url($params['espp_ip'])){
			$validator->addFieldError('espp_ip', $this->getText('setting.form.error.espp.ip'));
		} else {
			if(!empty($params['espp_ip'])) {
				if(in_array($params['espp_ip'], $parentAddresses)) {
					$validator->addFieldError('parent_ip', $this->getText('exists.parent.ip'));
				} else if($params['local_ip'] == $params['espp_ip']){
					$validator->addFieldError('espp_ip', $this->getText('espp.ip.equals.locale'));
				} else {
					$parentAddresses[] = $params['espp_ip'];
				}
			}
		}
		
		//espc
		for($i = 1;$i<5;$i++){
			$params['espc_ip_'.$i] = trim($params['espc_ip_'.$i]);
			if($params['espc_inuse_'.$i][0] == "yes" && empty($params['espc_ip_'.$i]) ||
				!empty($params['espc_ip_'.$i]) && !$this->is_ip($params['espc_ip_'.$i])){
				$validator->addFieldError('espc_ip_'.$i, $this->getText('setting.form.error.ip', array($this->getText('label.setting.espc.address.'.$i))));
			} else {
				if(!empty($params['espc_ip_'.$i])) {
					if(in_array($params['espc_ip_'.$i], $parentAddresses)) {
						$validator->addFieldError('parent_ip', $this->getText('exists.parent.ip'));
					} else if($params['local_ip'] == $params['espc_ip_'.$i]) {
						$validator->addFieldError('espc_ip', $this->getText('espc.ip.equals.locale'));
					} else {
						$parentAddresses[] = $params['espc_ip_'.$i];
					}
				}
			}
		}
		
		//validate advanced config
		//espp
//		if($params['espp_inuse'][0] == "yes") {
		$this->validateAdvancedItem($validator, $params, 'setting.lable.espp');
//		}
		
		//espc
		for($i = 1;$i<5;$i++){
			//if($params['espc_inuse_'.$i][0] == "yes") {
			$this->validateAdvancedItem($validator, $params, 'label.setting.espc.name.'.$i, "espc", "_".$i);
			//}
		}
	}
	
	private function validateAdvancedItem(&$validator, $params, $name, $prefix="espp", $suffix="") {
		$nameText = $this->getText($name);
		//auth_pwd
		if($prefix != 'espp' && !$this->check_password($params[$prefix.'_auth_pwd'.$suffix], True)) {
			$validator->addFieldError($prefix.'_auth_pwd'.$suffix, $this->getText('setting.form.error.auth.password', array($nameText)));
		}
		//tran
		if(in_array($params[$prefix.'_tran'.$suffix], array('tcp', 'aes', 'ssl'))) {
			switch($params[$prefix.'_tran'.$suffix]) {
				case 'ssl':
					if(!$this->is_port(trim($params[$prefix."_port_ssl".$suffix]))) {
						$validator->addFieldError($prefix."_port_ssl".$suffix, $this->getText("setting.form.error.ssl", array($nameText)));
					}
					break;
				case 'aes':
					if($prefix != 'espp') {
						if(empty($params[$prefix."_aes_pwd".$suffix]) || !$this->check_password($params[$prefix."_aes_pwd".$suffix], True)) {
							$validator->addFieldError($prefix."_aes_pwd".$suffix, $this->getText("setting.form.error.aesPwd", array($nameText)));
						}
					}
					break;
				case 'tcp':
					if(!$this->is_port(trim($params[$prefix."_port_tcp".$suffix]))) {
						$validator->addFieldError($prefix."_port_tcp".$suffix, $this->getText("setting.form.error.tcp", array($nameText)));
					}
					break;
			}
		} else {
			$validator->addFieldError($prefix.'_auth_pwd'.$suffix, $this->getText('setting.form.error.auth.tranType', array($nameText)));
		}
		
	}
	
	public function validateOnUpdateNpai($validator){
		$file = $_FILES["update_npai"];
		if($file['size']==0){
			$validator->addFieldError('npai_update',$this->getText('error.empyt.npai.update.file'));
		}
	}
	
	private function is_ipv4($ip){
		if(preg_match("/^([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$/", $ip)){
			return true;
		}else{
			return false;
		}
	}
	
	private function is_ipv6($ip){
		return preg_match('/\A
			(?:
			(?:
			(?:[a-f0-9]{1,4}:){6}
			|
			::(?:[a-f0-9]{1,4}:){5}
			|
			(?:[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){4}
			|
			(?:(?:[a-f0-9]{1,4}:){0,1}[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){3}
			|
			(?:(?:[a-f0-9]{1,4}:){0,2}[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){2}
			|
			(?:(?:[a-f0-9]{1,4}:){0,3}[a-f0-9]{1,4})?::[a-f0-9]{1,4}:
			|
			(?:(?:[a-f0-9]{1,4}:){0,4}[a-f0-9]{1,4})?::
			)
			(?:[a-f0-9]{1,4}:[a-f0-9]{1,4}
			|
			(?:(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}
			(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]))
			|
			(?:(?:(?:[a-f0-9]{1,4}:){0,5}[a-f0-9]{1,4})?::[a-f0-9]{1,4}
			|
			(?:(?:[a-f0-9]{1,4}:){0,6}[a-f0-9]{1,4})?::))
			(\/([0][0-9]{1,2}|[0-9]{1,2}|1[0-1][0-9]|12[0-8])){0,1}\Z/ix',
			$ip
			);
	}
	
	private function is_ip($ip){
		if($this->is_ipv4($ip) || $this->is_ipv6($ip)){
			return true;
		}else{
			return false;
		}
	}
	
	private function is_url($url){
		$re = preg_match("/[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+\.?/",$url);
		return $re;
	}
	
	private function is_port($port){
		if(preg_match("/^[0-9]+$/", $port)){
			if(intval($port) > 65535 || intval($port)<1)
			return false;
			else
			return true;
		}else{
			return false;
		}
	}
	
	private function check_password($pwd,$chklen=false){
		if($chklen && (strlen($pwd)<8 || strlen($pwd)>14)){
			return false;
		}elseif(preg_match("/&|>|<|\"|'|\\$|`/", $pwd)){
			return false;
		}else{
			return true;
		}
	}
	
	private function getText($key, $params=array()){
		return $this->NpaiSetting->getText($key, $params);
	}
	
	public function npaiServerConfig() {
		$this->_render(array('info' => $this->NpaiSetting->getNpaiServerConfig()));
	}
	
	public function updateNpaiServerConfig() {
		$result = null;
		$info = array();
		if($this->_hasError()) {
			$info = $this->_params['npaiServer'];
		} else {
			$info = $this->_params['npaiServer'];
			$this->NpaiSetting->setNpaiServerConfig($info);
			Cavy_Audit::newoperationLog('audit.setting.update.npai.server');
			$result = array("resultType" => True, 'resultText' =>  "update.npai.server.config.success");
			$info = $this->NpaiSetting->getNpaiServerConfig();
		}
		$this->_render(array('info' => $info, "result" => $result), "npaiServerConfig");
	}
	
	public function validateOnUpdateNpaiServerConfig($validator) {
		$params = $this->_params['npaiServer'];
		$validator->validateCheckboxOrSelect($params['aesEnabled'], array('enabled', 'disabled'), 'aesEnabled', "illegal.data");
		if($params['aesEnabled'] == "enabled" && (empty($params["aesPwd"]) || !$this->check_password($params["aesPwd"]))) {
			$validator->addFieldError("aesPwd", $this->getText("setting.form.error.server.aesPwd"));
		}
	}
	
	public function getDebugInfo(){
		list($re,$path) = $this->NpaiSetting->getDebugInfo();
		if($re>0){
			$msg = 'setting.npai.getDebugInfo.fail.'.$re;
			Cavy_Audit::newoperationLog('audit.setting.get.debugInfo.failed');
			$this->_render(array('info'=>$msg), 'result');
		}elseif(file_exists($path)){
			Cavy_Audit::newoperationLog('audit.setting.get.debugInfo.success');
			$this->downloads($path);
			@unlink($path);
		}
	}
	
	private function downloads($path) {
		if(!file_exists($path)){
			header("HTTP/1.0 404 Not Found");
			print ("File not found");
			exit();
		}else{
			header("Cache-Control: must-revalidate");
	        header("Pragma: cache");
			header("Content-Type: application/octet-stream; name=".basename($path).'"');
			header("Content-Transfer-Encoding: Binary");
			header('Content-Disposition: attachment; filename="'.basename($path).'"');
			header("Content-Length: ".filesize($path)); 
			readfile($path);
		}
	}
	
	public function replaceCert(){
		if($this->_hasError()) {
			$this->_render(array(), 'result');
		}else{
			$file = $_FILES['cert'];
			$re = $this->NpaiSetting->replaceCert($file);
			if($re===true){
				Cavy_Audit::newoperationLog('audit.setting.replace.success');
				$msg = 'setting.npai.relace.cert.succ';
			}else{
				Cavy_Audit::newoperationLog('audit.setting.replace.failed');
				$msg = 'setting.npai.relace.cert.fail.'.$re;
			}
			$this->_render(array('info'=>$msg), 'result');
		}
	}
	
	public function validateOnReplaceCert($validator) {
		$file = $_FILES["cert"];
		if($file['size']==0){
			$validator->addFieldError('npai_cert',$this->getText('error.empyt.npai.cert.file'));
		} else if(!preg_match('/.*\.nlic$/', $file['name'])) {
			$validator->addFieldError('npai_cert',$this->getText('setting.form.error.cert.file'));
		}
	}
	
	public function autoUpdateSetting(){
		if($this->_params['enable'] == "true") {
			Cavy_Audit::newoperationLog('audit.setting.autoUpdate.enabled');
		} else if($this->_params['enable'] == "false") {
			Cavy_Audit::newoperationLog('audit.setting.autoUpdate.disabled');
		}
		echo $this->NpaiSetting->autoUpdateSetting($this->_params['enable']);
	}
}
?>