<?php
Cavy::loadClass("Cavy_Log");
class NpaiSetting extends Cavy_Model {
	
	private $npaiHome = '';
	private $logXml = '';
	private $cmdXml = '';
	private $clientConfigXml = '';
	private $timeout = '';
	private $recoverXml = '';
	private $npaiVersion = '';
	private $localIpConfigFile = '';
	private $qpidConfigFile = '';
	private $devicesConfigFile = "";
	private $npaiStatXml = "";
	private $serviceConfigXml = '';
	private $autoUpdateConfig = '';
	
	public function __construct() {
		$this->npaiHome = Cavy::$ENV['nsc.home.dir']."/NPAI/";
		$this->logXml = $this->npaiHome."data/status/links.xml";
		$this->cmdXml = $this->npaiHome."data/status/cmdstatus.xml";
		$this->clientConfigXml = $this->npaiHome."config/client.xml";
		$this->timeout = $this->npaiHome."config/TIMEOUT";
		$this->recoverXml = $this->npaiHome."config/recover.xml";
		$this->npaiVersion = $this->npaiHome."config/version.xml";
		
		$this->localIpConfigFile = $this->npaiHome."config/LOCALADDR";
		$this->qpidConfigFile = $this->npaiHome."config/q-espc.conf";
		$this->devicesConfigFile = $this->npaiHome."config/devices.lst";
		
		$this->npaiStatXml = Cavy::$ENV['nsc.home.dir']."/store/nsc/npai/count.xml";
		$this->serviceConfigXml = $this->npaiHome."config/server.xml";
		
		$this->autoUpdateConfig = $this->npaiHome."config/AUTOUPDATE";
		$this->serverIpConfigFile = $this->npaiHome."config/SERVERADDR";
	}
	
	public function getNpaiSettingInfo(){
		$info = $this->getCilentInfo();
		$info['local_ip'] = $this->getClientSideIp();
		$info['status'] = $this->getNpaiStatus();
		$info['npai_info'] = $this->getNpaiInfo();
		return $info;
	}
							
	public function getNpaiStatus(){
		$status = array();
		$cmdStatus = $this->getStatusForCmd();
		$logStatus = $this->getStatusForLog();
		$clientinfo = $this->_GetClientIds();

		$disconnect_img = '/images/espc/state_disconnect_'.Cavy::$ENV['locale'].'.gif';
		$connect_img = '/images/espc/state_connect_'.Cavy::$ENV['locale'].'.gif';
		
		if($this->_isTimeOut($logStatus['time'])){
			$logText = $this->text('NPAI.status.log.timeout', array(), "npaiSetting");
			foreach($clientinfo as $key=>$value){
				if(array_key_exists($value,$cmdStatus)){
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $this->text('NPAI.status.cmd.timeout', array(), "npaiSetting");
					}else {
						$cmdText = $this->text('NPAI.status.cmd.succ', array(), "npaiSetting");
					}
				}else{
					$cmdText = $this->text('NPAI.status.cmd.fail', array(), "npaiSetting").$this->text('NPAI.status.fail.id.not.exist', array(), "npaiSetting");
				}
				
				$title = $cmdText;
				if(!empty($title)) {$title .= '<br />';}
				$title .= $logText;
				$status[$key]['img'] = '<img src="'.$disconnect_img.'" width="65" height="23" alt="connect" title="'.$title.'" style="vertical-align:top;" class="tipBox"/>';
				$status[$key]['connection'] = False;
				$status[$key]['comment'] = $title;
			}
		}else{
			foreach($clientinfo as $key=>$value){
				$logStatue = False;
				$cmdStatue = False;
				if(array_key_exists($value,$logStatus) && array_key_exists($value,$cmdStatus)){
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $this->text('NPAI.status.cmd.timeout', array(), "npaiSetting");
						if($logStatus[$value]['status']=='true'){
							$logText = $this->text('NPAI.status.log.succ', array(), "npaiSetting");
							$logStatue = True;
						}else{
							$logText = $this->text('NPAI.status.log.fail', array(), "npaiSetting").$logStatus[$value]['reason'];
						}
					}else{
						$cmdText = $this->text('NPAI.status.cmd.succ', array(), "npaiSetting");
						$cmdStatue = True;
						if($logStatus[$value]['status']=='true'){
							$logText = $this->text('NPAI.status.log.succ', array(), "npaiSetting");
							$logStatue = True;
						}else{
							$logText = $this->text('NPAI.status.log.fail', array(), "npaiSetting").$logStatus[$value]['reason'];
						}
					}
				}elseif(array_key_exists($value,$logStatus) && !array_key_exists($value,$cmdStatus)){
					$cmdText = $this->text('NPAI.status.cmd.fail', array(), "npaiSetting").$this->text('NPAI.status.fail.id.not.exist', array(), "npaiSetting");
					if($logStatus[$value]['status']=='true'){
						$logText = $this->text('NPAI.status.log.succ', array(), "npaiSetting");
						$logStatue = True;
					}else{
						$logText = $this->text('NPAI.status.log.fail', array(), "npaiSetting").$logStatus[$value]['reason'];
					}
				}elseif(!array_key_exists($value,$logStatus) && array_key_exists($value,$cmdStatus)){
					$logText = $this->text('NPAI.status.log.fail', array(), "npaiSetting").$this->text('NPAI.status.fail.id.not.exist', array(), "npaiSetting");
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $this->text('NPAI.status.cmd.timeout', array(), "npaiSetting");
					}else {
						$cmdText = $this->text('NPAI.status.cmd.succ', array(), "npaiSetting");
						$cmdStatue = True;
					}
				}else{
					$cmdText = $this->text('NPAI.status.cmd.fail', array(), "npaiSetting").$this->text('NPAI.status.fail.id.not.exist', array(), "npaiSetting");
					$logText = $this->text('NPAI.status.log.fail', array(), "npaiSetting").$this->text('NPAI.status.fail.id.not.exist', array(), "npaiSetting");
				}
				if($logStatue===True && $cmdStatue===True){
					$status[$key]['img'] = '<img src="'.$connect_img.'" width="65" height="23" alt="connect" style="vertical-align:top;"/>';
					$status[$key]['connection'] = True;
					$status[$key]['comment'] = '';
				}else{
					$title = $cmdText;
					if(!empty($title)) {$title .= '<br />';}
					$title .= $logText;
					$status[$key]['img'] = '<img src="'.$disconnect_img.'" width="65" height="23" alt="connect" title="'.$title.'" style="vertical-align:top;" class="tipBox"/>';
					$status[$key]['connection'] = False;
					$status[$key]['comment'] = $title;
				}
			}
		}

		return $status;
	}
	
	public function recoverSetting(){
		$recoverInfo = $this->getRecoverXmlInfo();
		if(!empty($recoverInfo)){
			$client = @simplexml_load_file($this->clientConfigXml);
			foreach($client->broker as $broker){
				$id = (int)$broker['id'];
				$broker->port->tcp = $recoverInfo[$id]['tcp'];
				$broker->port->ssl = $recoverInfo[$id]['ssl'];
				$broker->userid = $recoverInfo[$id]['userid'];
				$broker->passwd = $recoverInfo[$id]['passwd'];
				$broker->transport = $recoverInfo[$id]['transport'];
				$broker->pkey = $recoverInfo[$id]['pkey'];
				$broker->ftp_user = $recoverInfo[$id]['ftp_user'];
				$broker->ftp_pwd = $recoverInfo[$id]['ftp_pwd'];
				$broker->ftp_port = $recoverInfo[$id]['ftp_port'];
				$broker['uploadlog'] = $recoverInfo[$id]['uploadlog'];
			}
			$client->asXML($this->clientConfigXml);
			return "setting.recover.succ";
		}else{
			return "setting.recover.fail";
		}
	}
	
	public function recoverEspcSetting(){
		$recoverInfo = $this->getRecoverXmlInfo();
		if(!empty($recoverInfo)){
			$client = @simplexml_load_file($this->clientConfigXml);
			foreach($client->broker as $broker){
				$id = (int)$broker['id'];
				if($id == 0) {continue;}//espp
				$broker->port->tcp = $recoverInfo[$id]['tcp'];
				$broker->port->ssl = $recoverInfo[$id]['ssl'];
				$broker->userid = $recoverInfo[$id]['userid'];
				$broker->passwd = $recoverInfo[$id]['passwd'];
				$broker->transport = $recoverInfo[$id]['transport'];
				$broker->pkey = $recoverInfo[$id]['pkey'];
				$broker->ftp_user = $recoverInfo[$id]['ftp_user'];
				$broker->ftp_pwd = $recoverInfo[$id]['ftp_pwd'];
				$broker->ftp_port = $recoverInfo[$id]['ftp_port'];
			}
			$client->asXML($this->clientConfigXml);
			return "setting.recover.succ";
		}else{
			return "setting.recover.fail";
		}
	}
	
	public function updateNpai($file){
		$updateNpaiFile = Cavy::$ENV['nsc.home.dir'].'/temp/NPAI/tmp_npai_'.time().'.dat';
		move_uploaded_file($file['tmp_name'],$updateNpaiFile);
		if(file_exists($updateNpaiFile)){
			$cmd = 'cd /d "'.$this->npaiHome.'/bin/update" && python -O manu_update.py --product espc --file "'.$updateNpaiFile.'"';
			$re = -1;
			$output = array();
			session_write_close();
			exec($cmd,$output,$re);
			if($re == 0) {
	   			Cavy_Log::debug('Update NPAI Interface Success');
	   			return True;
	   		} else {
	   			Cavy_Log::debug('Update NPAI Interface Error, Cmd return Code:'.$re);
				return False;
	   		}
		}else{
			return False;
		}
		
	}
	
	private function getRecoverXmlInfo(){
		$info = array();
		if(file_exists($this->recoverXml)){
			$dom = @simplexml_load_file($this->recoverXml);
			foreach($dom->broker as $broker){
				$id = (int)$broker['id'];
				$info[$id] = array(
								'tcp'=>(string)$broker->port->tcp,
								'ssl'=>(string)$broker->port->ssl,
								'userid'=>(string)$broker->userid,
								'passwd'=>(string)$broker->passwd,
								'transport'=>(string)$broker->transport,
								'pkey'=>(string)$broker->pkey,
								'ftp_user'=>(string)$broker->ftp_user,
								'ftp_pwd'=>(string)$broker->ftp_pwd,
								'ftp_port'=>(string)$broker->ftp_port,
								'uploadlog'=>(string)$broker['uploadlog'],
							);
			}
			return $info;
		}else{
			return array();
		}
	}
	
	private function getStatusForLog(){
		$xml_path = $this->logXml;
		if(!file_exists($xml_path)){
			return array();
		}
		$status = array();
		$dom = @simplexml_load_file($xml_path);
		if(!$dom) {return array();}
		$time = (int)$dom->time;
		$status['time'] = $time;
		foreach($dom->host as $host){
			$id = trim((string)$host['id']);
			$links = (string)$host['status'];
			$reason = base64_decode((string)$host['lasterr']);
			$status[$id] = array('status'=>$links,'reason'=>$reason);
		}
		return $status;
	}
	
	private function getStatusForCmd(){
		$xml_path = $this->cmdXml;
		if(!file_exists($xml_path)){
			return array();
		}
		$status = array();
		$dom = @simplexml_load_file($xml_path);
		if(!$dom) {return array();}
		foreach($dom->host as $host){
			$id = trim((string)$host['id']);
			$time = (string)$host['time'];
			$status[$id] = array('time'=>$time);
		}
		return $status;
	}
	
	private function getCilentInfo(){
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) return array();
		$info = array();
		foreach($dom->broker as $broker){
			$id = (string)$broker['id'];
			$auth_pwd = base64_decode((string)$broker->passwd);
			$ftp_pwd = base64_decode((string)$broker->ftp_pwd);
			$pkey = base64_decode((string)$broker->pkey);
			if($id=='0'){
				$info['espp_ip'] = (string)$broker->host;
				$info['espp_port_ssl'] = (string)$broker->port->ssl;
				$info['espp_port_tcp'] = (string)$broker->port->tcp;
//				$info['espp_auth_pwd'] = empty($auth_pwd) ? '' : substr(MD5($auth_pwd),0,8);
				$info['espp_tran'] = (string)$broker->transport;
				$info['espp_aes_pwd'] =  empty($pkey) ? '' : substr(MD5($pkey),0,8);
				$info['espp_inuse'] = (string)$broker['inuse'];
				$info['espp_log'] = (string)$broker['uploadlog'];
			}else{
				$info['espc_ip_'.$id] = (string)$broker->host;
				$info['espc_port_ssl_'.$id] = (string)$broker->port->ssl;
				$info['espc_port_tcp_'.$id] = (string)$broker->port->tcp;
				$info['espc_auth_pwd_'.$id] = empty($auth_pwd) ? '' : substr(MD5($auth_pwd),0,8);
				$info['espc_tran_'.$id] = (string)$broker->transport;
				$info['espc_aes_pwd_'.$id] = empty($pkey) ? '' :substr(MD5($pkey),0,8);
				$info['espc_inuse_'.$id] = (string)$broker['inuse'];
			}
		}
		return $info;
	}
	
	public function updateNpaiSetting($info){
		$this->updateClientXml($info);
		$this->updateClientSideIp($info['local_ip']);
		Cavy::getModel("deviceConfig")->configWerSvc();
	}
	
	private function updateClientXml($info){
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) return False;
		foreach($dom->broker as $broker){
			$id = $broker['id'];
			$passwd = "";
			if($id=='0'){
				$host = trim($info['espp_ip']);
				$ssl = trim($info['espp_port_ssl']);
				$tcp = trim($info['espp_port_tcp']);
				$passwd = $info['espp_auth_pwd'];
				$transport = $info['espp_tran'];
				$pkey = $info['espp_aes_pwd'];
				$inuse = $info['espp_inuse'][0]=='yes'?'yes':'no';
				$broker['uploadlog'] = $info['espp_log'][0]=='yes'?'yes':'no';
			}else{
				$host = trim($info['espc_ip_'.$id]);
				$ssl = trim($info['espc_port_ssl_'.$id]);
				$tcp = trim($info['espc_port_tcp_'.$id]);
				$passwd = $info['espc_auth_pwd_'.$id];
				$transport = $info['espc_tran_'.$id];
				$pkey = $info['espc_aes_pwd_'.$id];
				$inuse = $info['espc_inuse_'.$id][0]=='yes'?'yes':'no';
				$old_auth_pwd = base64_decode((string)$broker->passwd);
				if(substr(MD5($old_auth_pwd),0,8)!=$passwd){
					$broker->passwd = base64_encode($passwd);
				}
			}
			$broker['inuse'] = $inuse;
			$broker->host = $host;
			
			$broker->transport = $transport;
			switch($transport) {
				case 'ssl':$broker->port->ssl = $ssl;break;
				case 'aes':
					if($id != '0'){
						$old_p_key = base64_decode((string)$broker->pkey);
						if(substr(MD5($old_p_key),0,8)!=$pkey){
							$broker->pkey = base64_encode($pkey);
						}
					}
					break;
				case 'tcp':$broker->port->tcp = $tcp;break;
			}
		}
		return $dom->asXML($this->clientConfigXml);
	}
	
	private function _GetClientIds(){
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) {return array();}
		$info = array();
		foreach($dom->broker as $broker){
			$id = (string)$broker['id'];
			$host = trim((string)$broker->host);
			if(!empty($host) && $broker['inuse']=='yes'){
				$info[$id] = $host;
			}
		}
		return $info;
	}
	
	private function _isTimeOut($time){
		$content = @file_get_contents($this->timeout);
		$content = trim($content);
		$content = (int)$content;
		$now = time();
		if(($now-$time)>$content){
			return true;
		}else{
			return false;
		}
	}
	
	private function getNpaiInfo(){
		$dom = @simplexml_load_file($this->npaiVersion);
		if(!$dom) return array();
		$info = array();
		$info['version'] = (string)$dom->version;
		if(!empty($dom->updatetime)){
			$info['updateTime'] = date("Y-m-d H:i:s",(int)$dom->updatetime);
		}else{
			$info['updateTime'] = "";
		}
		if(file_exists($this->autoUpdateConfig)){
			$info['autoUpdate'] = @file_get_contents($this->autoUpdateConfig);
		}
		return $info;
	}
	
	public function getText($key, $params=array()) {
		return $this->text($key, $params, 'npaiSetting');
	}
	
	public function updateClientSideIp($ip){
		return !!@file_put_contents($this->localIpConfigFile, $ip);
	}
	
	public function getClientSideIp() {
		$ip = @file_get_contents($this->localIpConfigFile);
		return trim($ip);
	}
	
	public function updateServerSideIp($ip){
		return !!@file_put_contents($this->serverIpConfigFile, $ip);
	}
	
	public function getServerSideIp() {
		$ip = @file_get_contents($this->serverIpConfigFile);
		return trim($ip);
	}
	
	public function updateCertificate() {
		$path = $this->npaiHome.'/bin/tools/';
		$cmd = 'cd /d "'.$path.'" && python winmkcert.py 0';
		session_write_close();
		$resultInfo = array();
		$reusltType = -1;
   		$re = exec($cmd, $resultInfo, $resultType);
   		if($resultType === 0) {
   			Cavy_Log::debug('Update NPAI Certificate Success');
   			return True;
   		} else {
   			Cavy_Log::debug('Update NPAI Certificate Error, Cmd return Code:'.$resultType);
			return False;
   		}
	}
	
	public function updateQpid($ip) {
		$configs = @file($this->qpidConfigFile);
		if(!$configs) {return False;}
		$sslCertName = "ssl-cert-name=";
		foreach($configs as &$c) {
			$c = trim($c);
			if(strstr($c, $sslCertName) === False) {continue;}
			$c = $sslCertName.$ip;
		}
		$handle = @fopen($this->qpidConfigFile, 'wb');
		if($handle){
			fwrite($handle, implode("\n", $configs));
			fclose($handle);
			return True;
		}else{
			return False;
		}
	}
	
	public function updateDevicesList($ipAndHashList=array()) {
		$handle = @fopen($this->devicesConfigFile, 'wb');
		if($handle){
			$content = "# ip_hash\n";
			$content .= implode("\n", $ipAndHashList);
			fwrite($handle, $content);
			fclose($handle);
			return True;
		}else{
			return False;
		}
	}
	
	public function getParentsInfo() {
		$xml = @simplexml_load_file($this->clientConfigXml);
		if(!$xml)return array();
		$parents = array();
		foreach($xml->broker as $broker) {
			if($broker["inuse"] == "yes") {
				$parents[] = (string)$broker->host;
			}
		}
		return $parents;
	}
	
	public function manageEsppUse($use=True) {
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) return 'fail';
		foreach($dom->broker as $broker){
			if($broker['id']=='0'){
				$broker['inuse'] = $use?'yes':'no';
				break;
			}
		}
		return $dom->asXML($this->clientConfigXml) ? "success" :'fail';
	}
	
	public function esppIsUse() {
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) return False;
		foreach($dom->broker as $broker){
			if($broker['id']=='0'){
				return (string)$broker['inuse'] == 'yes';
			}
		}
		return False;
	}
	
	public function getEsppStatus() {
		$status = $this->getNpaiStatus();
		return array_key_exists(0, $status) ? $status[0] : False; 
	}
	
	public function getEsppInfo() {
//		$npaiStatInfo = $this->getNpaiStatInfo();
//		return array_key_exists(0, $npaiStatInfo) ? $npaiStatInfo[0] : False; 
		$esppAddress = $this->getEsppAddress();
		if($esppAddress) {
			$statInfos = $this->_getStatInfo();
			if(array_key_exists($esppAddress, $statInfos)) {
				return $statInfos[$esppAddress];
			}
		}
		return array("statusCount" => 0, "logCount" => 0);
	}
	
	private function getEsppAddress() {
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) {return False;}
		$info = array();
		foreach($dom->broker as $broker){
			if((string)$broker['id'] == '0') {
				return trim((string)$broker->host);
			}
		}
		return False;
	}
	public function getEsppEnabledAddress() {
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) {return False;}
		$addrs = array();
		
		foreach($dom->broker as $broker) {
			if($broker["inuse"] == "yes" && (string)$broker['id'] == '0') {
				$addrs[] = (string)$broker->host;
			}
		}
		return $addrs;
	}
	
	public function getEspcEnabledAddress() {
		$dom = @simplexml_load_file($this->clientConfigXml);
		if(!$dom) {return False;}
		$addrs = array();
		
		foreach($dom->broker as $broker) {
			if($broker["inuse"] == "yes" && (string)$broker['id'] != '0') {
				$addrs[] = (string)$broker->host;
			}
		}
		return $addrs;
	}
	public function getNpaiStatInfo() {
		$clients = $this->_GetClientIds();
		$statInfos = $this->_getStatInfo();
		$npaiStatInfos = array();
		foreach($clients as $key=>$client) {
			if(array_key_exists($client, $statInfos)) {
				$npaiStatInfos[$key] = $statInfos[$client];
			}
		}
		return $npaiStatInfos;
	}
	
	
	private function _getStatInfo() {
		$dom = @simplexml_load_file($this->npaiStatXml);
		if(!$dom) return array();
		$statInfos = array();
		foreach($dom->parent as $parent) {
			$id = (string)$parent['addr'];
			$dstatusCount = 0;
			$dlogCount = 0;
			foreach($parent->item as $item) {
				$type = (string)$item['type'];
				${$type.'Count'} = (int)$item['count'];
			}
			$statInfos[$id] = array("statusCount" => $dstatusCount, "logCount" => $dlogCount);
		}
		return $statInfos;
	}
	
	public function getNpaiServerConfig() {
		$xml = @simplexml_load_file($this->serviceConfigXml);
		if(!$xml) return array();
		$info = array();
		$pkey = (string)$xml->local->pkey;
		$info['aesEnabled'] = "aes" == (string)$xml->local->transport ? "enabled" : "disabled";
		$info['aesPwd'] = empty($pkey) ? '' :substr(MD5($pkey),0,8);
		return $info;
	}
	
	public function setNpaiServerConfig($info) {
		$xml = @simplexml_load_file($this->serviceConfigXml);
		if(!$xml) False;
		if($info['aesEnabled'] == "enabled") {
			$pkey = (string)$xml->local->pkey;
			$pkey = empty($pkey) ? '' :substr(MD5($pkey),0,8);
			$xml->local->transport = "aes";
			if($pkey != $info['aesPwd']) {
				$xml->local->pkey = base64_encode($info['aesPwd']);
			}
		} else {
			$xml->local->transport = "tcp";
		}
		return $xml->saveXml($this->serviceConfigXml);
	}
	
	public function getDebugInfo(){
		$path = $this->npaiHome.'/bin/tools/';
		$cmd = 'cd /d "'.$path.'" && python getinfos.py';
		session_write_close();
		$resultInfo = array();
		$reusltType = -1;
   		exec($cmd, $resultInfo, $resultType);
   		switch($resultType) {
   			case 0:
   			case 6:
   			case 7:
   			case 8:
   			case 9:
   				return array($resultType,trim($resultInfo[0]));
   			default:
   				return array(1000, "unknown reason");
   		}
	}
	
	public function autoUpdateSetting($value){
		if(file_exists($this->autoUpdateConfig)){
			$svcManagerObj = Cavy::getModel("svcManager");
			if($value=='true'){
				@file_put_contents($this->autoUpdateConfig,'true');
				$svcManagerObj->restartSvc(array("webdaemon"));
				return 'true';
			}elseif($value=='false'){
				@file_put_contents($this->autoUpdateConfig,'false');
				$svcManagerObj->restartSvc(array("webdaemon"));
				return 'true';
			}else{
				return 'false';
			}
		}else{
			return 'false';
		}
	}
}
?>