<?php
class NpaiSettingController extends Cavy_Controller_Action {
	public $models = 'npaiSetting,audit,cloudSetting';
	private $pylib='/bin/super bzypython /opt/nsfocus/NPAI/bin/runtime/getPortalStatus.py';
	public function index(){
		$info = $this->NpaiSetting->getNpaiSettingInfo();
		if(isset($this->_params['alertInfo'])){
			$info['alertInfo'] = $this->_params['alertInfo'];
		}
		$isAllowPortal = $this->CloudSetting->get_profession_config();
		$getPortalBack = $this->CloudSetting->isConnPortal();
		$isConnPortal = ($isAllowPortal['allow'] and $getPortalBack);
		$info['isConnPortal'] = $isConnPortal;
		$this->_render($info);
	}

	public function getPortalStatus(){
		$info = $this->NpaiSetting->getNpaiSettingInfo();
		$portal_info = $this->CloudSetting->getPortalStatusInfo();
		if($portal_info['backInfo']['code']=='2000'){
			$flag = False;
			for ($i=0; $i < 5; $i++) {
				$espc_inuse = 'espc_inuse_'.$i;
				if($info[$espc_inuse]=='yes'){
					$flag = True;
					break;
				}
			}
			if($portal_info['backInfo']['status']=='1'){
				if($info['espp_inuse']!='yes' || $info['espp_log']!='yes' || $flag){
					$this->CloudSetting->mutexEspcEspp("blind");
					$this->CloudSetting->makeUploadXml();
					$this->NpaiSetting->rebootNpai();
					$this->NpaiSetting->restartWebtoid();
				}
			}else{
				if($info['espp_inuse']=='yes' || $flag){
					$this->CloudSetting->mutexEspcEspp("blind");
					$this->CloudSetting->mutexEspcEspp("unblind");
					$this->CloudSetting->makeUploadXml();
					$this->NpaiSetting->rebootNpai();
					$this->NpaiSetting->restartWebtoid();
				}
			}
		}
		echo $portal_info['back'];
	}

	public function getValidateLocalIp(){
		$result = array('alert'=>False);
		$localIp = $this->CloudSetting->getLocalIp();
		if(!$localIp){
			$result['alert'] = True;
			$result['alertInfo'] = $this->getText('setting.localip.is.nUll');
		}
		$result['localIp'] = $localIp;
		echo json_encode($result);
	}

	public function getAccessDialog(){
        $this->_render();
	}

	public function getRejectDialog(){
	    $this->_render();
	}

	public function quickAccess(){ 
		$info = array();
		$info['alert'] = False;

		$param = ' -b 2>&1';
		$cmd=$this->pylib.$param;
		session_write_close();
		@exec($cmd,$out,$rev);

		if($rev > 0) {
			$info['alert'] = True;
			$info['alertInfo'] = $this->getText('setting.bing.fail');
		}else{
			// $this->CloudSetting->mutexEspcEspp("blind");
			// $this->CloudSetting->makeUploadXml();
			// $this->NpaiSetting->rebootNpai();
			// $this->NpaiSetting->restartWebtoid();
			$info['url'] = $out[0];
		}

		echo json_encode($info);
	}

	public function cancelBing(){
		$param = ' -u 2>&1';
        $cmd=$this->pylib.$param;
        $logtext=array($this->getText('setting.cancel.bing.ok'),$this->getText('setting.cancel.bing.fail'));
        session_write_close();
		@exec($cmd,$out,$rev);
		if($rev =='0'){
			$this->CloudSetting->mutexEspcEspp("unblind");
			$this->CloudSetting->makeUploadXml();
			$this->NpaiSetting->rebootNpai();
			$this->NpaiSetting->restartWebtoid();
		}
        $this->_render(array('rev'=>$rev,'logtext'=>$logtext),'success');
	}

	public function update(){
		$this->_params['setting']['espp_ip'] = trim($this->_params['setting']['espp_ip']);
		for($i = 1;$i<5;$i++){
			$this->_params['setting']['espc_ip_'.$i] = trim($this->_params['setting']['espc_ip_'.$i]);
		}
		if($this->_hasError()) {
			$this->_redirect('index','npaiSetting',array('alertInfo'=>'setting.update.fail'));
		}else{
			$this->Audit->operationLog($this->getText('audit.setting.update'));
			$this->NpaiSetting->updateNpaiSetting($this->_params['setting']);
			$this->CloudSetting->makeUploadXml();
			$this->NpaiSetting->rebootNpai();
			$this->NpaiSetting->restartWebtoid();
			system("/bin/super kill -9 `ps -elf | grep cneos-logger.py | grep -v grep | awk '{print $4}'` > /dev/null 2>&1");
		//	$this->Audit->operationLog($this->getText('audit.setting.update'));
			$this->_redirect('index','npaiSetting',array('alertInfo'=>'setting.update.succ'));
		}
	}
	
	public function getStatus(){
		$status = $this->NpaiSetting->getNpaiStatus();
		echo json_encode($status);
	}
	
	public function recoverSetting(){
		$msg = $this->NpaiSetting->recoverSetting();
		$this->NpaiSetting->rebootNpai();
		$this->NpaiSetting->restartWebtoid();
		$this->Audit->operationLog($this->getText('audit.setting.recover'));
		echo $msg;
	}
	
	public function updateNpai(){
		if($this->_hasError()) {
			$msg = $this->getFieldErrors();
			$this->_redirect('index','npaiSetting',array('alertInfo'=>$msg['npai_update'][0]));
		}else{
			$file = $_FILES['update_npai'];
			$re = $this->NpaiSetting->updateNpai($file);
			if($re){
				$msg = 'setting.npai.update.succ';
			}else{
				$msg = 'setting.npai.update.fail';
			}
			$this->NpaiSetting->operationLog_Record_Send($this->getText($msg));
			$this->_redirect('index','npaiSetting',array('alertInfo'=>$msg));
		}	
	}
	
	public function getDebugInfo(){
		list($re,$path) = $this->NpaiSetting->getDebugInfo();
		if($re>0){
			$msg = 'setting.npai.getDebugInfo.fail.'.$re;
			$this->Audit->operationLog($this->getText('audit.setting.get.debugInfo.fail'));
			$this->_redirect('index','npaiSetting',array('alertInfo'=>$msg));
		}elseif(file_exists($path)){
			$this->Audit->operationLog($this->getText('audit.setting.get.debugInfo.succ'));
			$this->downloads($path);
			@unlink($path);
		}
	}
	
	public function autoUpdateSetting(){
		if($this->_hasError()) {
			echo 'false';
		}else{
			$this->Audit->operationLog($this->getText('audit.setting.autoUpdate.'.$this->_params['enable']));
			$re = $this->NpaiSetting->autoUpdateSetting($this->_params['enable']);
			echo $re;
		}
	}

	private function downloads($path) {
		if(!file_exists($path)){
			header("HTTP/1.0 404 Not Found");
			print ("File not found");
			exit();
		}else{
			header("Cache-Control: must-revalidate");
	        header("Pragma: cache");
			header("Content-Type: application/octet-stream; name=".basename($path).'"');
			header("Content-Transfer-Encoding: Binary");
			header('Content-Disposition: attachment; filename="'.basename($path).'"');
			header("Content-Length: ".filesize($path)); 
			readfile($path);
		}
	}
	
	public function validateOnUpdate($validator) {
		$params = $this->_params['setting'];
		$params['local_ip'] = trim($params['local_ip']);
		if(empty($params['local_ip']) || !$this->is_ip($params['local_ip'])){
			$validator->addFieldError('local_ip', _('IP为空或格式错误'));
		}
		if(!empty($params['espp_ip']) && !$this->is_ip($params['espp_ip']) && !$this->is_url($params['espp_ip'])){
			$validator->addFieldError('espp_ip', _('IP格式错误'));
		}
		for($i = 1;$i<5;$i++){
			$params['espc_ip_'.$i] = trim($params['espc_ip_'.$i]);
			if(!empty($params['espc_ip_'.$i]) && !$this->is_ip($params['espc_ip_'.$i])){
				$validator->addFieldError('espc_ip_'.$i, _('IP格式错误'));
			}
		}	
		if(!empty($params['ftp_ip']) && !$this->is_ip($params['ftp_ip'])){
			$validator->addFieldError('ftp_ip', _('IP格式错误'));
		}
		if(!empty($params['ftp_port']) && !$this->is_port($params['ftp_port'])){
			$validator->addFieldError('ftp_port', _('端口格式错误'));
		}
		
		if(!empty($params['espp_ip']) && !$this->is_port($params['espp_port_ssl'])){
			$validator->addFieldError('espp_port_ssl', _('端口为空或格式错误'));
		}
		if(!empty($params['espp_ip']) && !$this->is_port($params['espp_port_tcp'])){
			$validator->addFieldError('espp_port_tcp', _('端口为空或格式错误'));
		}
		/*if(!empty($params['espp_ip']) && !$this->check_password($params['espp_auth_pwd'],true)){
			$validator->addFieldError('espp_auth_pwd', _('密码包含非法字符'));
		}*/
		if($params['espp_tran']!='ssl' && $params['espp_tran']!='aes' &&  $params['espp_tran']!='tcp'){
			$validator->addFieldError('espp_tran', _('传输方式错误'));
		}
		/*if($params['espp_tran']=='aes' && !$this->check_password($params['espp_aes_pwd'])){
			$validator->addFieldError('espp_aes_pwd', _('AES密码为空或包含特殊字符'));
		}*/
		if(empty($params['espp_ip']) && $params['espp_inuse'][0]=='yes'){
			$validator->addFieldError('espp_ip', _('请先填写地址'));
		}
		for($i = 1;$i<5;$i++){
			if(!empty($params['espc_ip_'.$i]) && !$this->check_password($params['espc_auth_pwd_'.$i],true)){
				$validator->addFieldError('espc_auth_pwd_'.$i, _('密码包含非法字符'));
			}
			if(!empty($params['espc_ip_'.$i]) && !$this->is_port($params['espc_port_ssl_'.$i])){
				$validator->addFieldError('espc_port_ssl_'.$i, _('端口为空或格式错误'));
			}
			if(!empty($params['espc_ip_'.$i]) && !$this->is_port($params['espc_port_tcp_'.$i])){
				$validator->addFieldError('espc_port_tcp_'.$i, _('端口为空或格式错误'));
			}
			if(!empty($params['espc_ftp_port_'.$i]) && !$this->is_port($params['espc_ftp_port_'.$i])){
				$validator->addFieldError('espc_port_tcp_'.$i, _('端口格式错误'));
			}
			if(!empty($params['espc_ftp_port_'.$i]) && empty($params['espc_ftp_pwd_'.$i])){
				$validator->addFieldError('espc_ftp_pwd_'.$i, _('FTP密码为空'));
			}
			if(!empty($params['espc_ftp_pwd_'.$i]) && !$this->check_password($params['espc_ftp_pwd_'.$i])){
				$validator->addFieldError('espc_ftp_pwd_'.$i, _('密码包含非法字符'));
			}
			if(empty($params['espc_ftp_port_'.$i]) && !empty($params['espc_ftp_pwd_'.$i])){
				$validator->addFieldError('espc_ftp_port_'.$i, _('FTP端口为空'));
			}
			if($params['espc_tran_'.$i]!='ssl' && $params['espc_tran_'.$i]!='aes' &&  $params['espc_tran_'.$i]!='tcp'){
				$validator->addFieldError('espc_tran_'.$i, _('传输方式错误'));
			}
			if($params['espc_tran_'.$i]=='aes' && !$this->check_password($params['espc_aes_pwd_'.$i])){
				$validator->addFieldError('espc_aes_pwd_'.$i, _('AES密码为空或包含特殊字符'));
			}
			if(empty($params['espc_ip_'.$i]) && $params['espc_inuse_'.$i][0]=='yes'){
				$validator->addFieldError('espc_ip_'.$i, _('请先填写地址'));
			}
		}

		$isAllowPortal = $this->CloudSetting->get_profession_config();
		$getPortalBack = $this->CloudSetting->isConnPortal();
		$isConnPortal = ($isAllowPortal['allow'] and $getPortalBack);
		if($isConnPortal){
			for($i=1; $i<5; $i++){
				if($params['espc_inuse_'.$i][0]=='yes'){
					$validator->addFieldError('espp_inuse', _('连接portal时,不能连接ESPC'));
					break;
				}
			}
		}

	}
	
	public function validateOnUpdateNpai($validator){
		$file = $_FILES["update_npai"];
		if($file['size']==0){
			$validator->addFieldError('npai_update','setting.npai.update.fail');
			return ;
		}
	}
	
	public function validateOnReplaceCert($validator){
		$file = $_FILES["cert"];
		if($file['size']==0){
			$validator->addFieldError('cert','setting.npai.relace.cert.fail.5');
			return ;
		}
	}

	public function validateOnAutoUpdateSetting($validator) {
		$enable = trim($this->_params['enable']);
		if($enable!='true' && $enable!='false'){
			$validator->addFieldError('update_npai',_('输入参数错误'));
		}
	}

	private function is_ipv4($ip){
		if(preg_match("/^([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.([0][0-9]{1,2}|[0-9]{1,2}|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$/", $ip)){
			return true;
		}else{
			return false;
		}
	}
	
	private function is_ip6($ip){
		return preg_match('/\A
			(?:
			(?:
			(?:[a-f0-9]{1,4}:){6}
			|
			::(?:[a-f0-9]{1,4}:){5}
			|
			(?:[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){4}
			|
			(?:(?:[a-f0-9]{1,4}:){0,1}[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){3}
			|
			(?:(?:[a-f0-9]{1,4}:){0,2}[a-f0-9]{1,4})?::(?:[a-f0-9]{1,4}:){2}
			|
			(?:(?:[a-f0-9]{1,4}:){0,3}[a-f0-9]{1,4})?::[a-f0-9]{1,4}:
			|
			(?:(?:[a-f0-9]{1,4}:){0,4}[a-f0-9]{1,4})?::
			)
			(?:[a-f0-9]{1,4}:[a-f0-9]{1,4}
			|
			(?:(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}
			(?:[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]))
			|
			(?:(?:(?:[a-f0-9]{1,4}:){0,5}[a-f0-9]{1,4})?::[a-f0-9]{1,4}
			|
			(?:(?:[a-f0-9]{1,4}:){0,6}[a-f0-9]{1,4})?::))
			(\/([0][0-9]{1,2}|[0-9]{1,2}|1[0-1][0-9]|12[0-8])){0,1}\Z/ix',
			$ip
			);
	}
	
	private function is_ip($ip){
		if($this->is_ipv4($ip) || $this->is_ipv4($ip)){
			return true;
		}else{
			return false;
		}
	}
	
	private function is_url($url){
		$re = preg_match("/[a-zA-Z0-9][-a-zA-Z0-9]{0,62}(\.[a-zA-Z0-9][-a-zA-Z0-9]{0,62})+\.?/",$url);
		return $re;
	}
	
	private function is_port($port){
		if(preg_match("/^[0-9]+$/", $port)){
			if(intval($port) > 65535 || intval($port)<1)
			return false;
			else
			return true;
		}else{
			return false;
		}
	}
	
	private function check_password($pwd,$chklen=false){
		if($chklen && (strlen($pwd)<8 || strlen($pwd)>14)){
			return false;
		}elseif(preg_match("/&|>|<|\"|'|\\$|`/", $pwd)){
			return false;
		}else{
			return true;
		}
	}
	
	private function getText($key){
		$locale_path = '/opt/nsfocus/NPAI/web/NF/locale/npaiSetting_'.Cavy::$ENV['locale'].'.locale.php';
		$text = include($locale_path);
		return $text[$key];
	}
}
?>