<?php
class NpaiSetting extends Cavy_Model {
	private $log_xml = '/opt/nsfocus/NPAI/data/status/links.xml';
	private $cmd_xml = '/opt/nsfocus/NPAI/data/status/cmdstatus.xml';
	private $local_ip_xml = '/opt/nsfocus/NPAI/config/LOCALADDR';
	private $client_xml = '/opt/nsfocus/NPAI/config/client.xml';
	private $timeout = '/opt/nsfocus/NPAI/config/TIMEOUT';
	private $recover_xml = '/opt/nsfocus/NPAI/config/recover.xml';
	private $npai_version = '/opt/nsfocus/NPAI/config/version.xml';
	private $autoUpdate_path = '/opt/nsfocus/NPAI/config/AUTOUPDATE';
	private $editespp_path = '/opt/nsfocus/NPAI/config/EDITESPP';
	private $espp_address = 'espp.api.nsfocus.com';

	
	public function getNpaiSettingInfo(){
		$info = array();
		$info = $this->getCilentInfo();
		$info['local_ip'] = $this->getLocalIp();
		$info['status'] = $this->getNpaiStatus();
		$info['npai_info'] = $this->getNpaiInfo();
		return $info;
	}
							
	public function getNpaiStatus(){
		$status = array();
		$cmdStatus = $this->getStatusForCmd();
		$logStatus = $this->getStatusForLog();
		$clientinfo = $this->_GetClientIds();
		$text = Cavy::getModel('NpaiText')->getText();
		$disconnect_img = 'state_disconnect_'.Cavy::$ENV['locale'].'.gif';
		$connect_img = 'state_connect_'.Cavy::$ENV['locale'].'.gif';

		if($this->_isTimeOut($logStatus['time'])){
			$logText = $text['NPAI.status.log.timeout'];
			foreach($clientinfo as $key=>$value){
				if(array_key_exists($value,$cmdStatus)){
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $text['NPAI.status.cmd.timeout'];
					}else{
						$cmdText = $text['NPAI.status.cmd.succ'];
					}
				}else{
					$cmdText = $text['NPAI.status.cmd.fail']." the id is not exist in xml";
				}
				$title = $cmdText.'<br>'.$logText;
				$status[$key]['img'] = '<img src="/espc/images/'.$disconnect_img.'" width="65" height="23" alt="connect" title="'.$title.'" style="vertical-align:top;" class="tipBox"/>';
			}
		}else{
			foreach($clientinfo as $key=>$value){
				if(array_key_exists($value,$logStatus) && array_key_exists($value,$cmdStatus)){
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $text['NPAI.status.cmd.timeout'];
						if($logStatus[$value]['status']=='true'){
							$logText = $text['NPAI.status.log.succ'];
						}else{
							$logText = $text['NPAI.status.log.fail'].$logStatus[$value]['reason'];
						}
					}else{
						$cmdText = $text['NPAI.status.cmd.succ'];
						if($logStatus[$value]['status']=='true'){
							$logText = true;
							$cmdText = true;
						}else{
							$logText = $text['NPAI.status.log.fail'].$logStatus[$value]['reason'];
						}
					}
				}elseif(array_key_exists($value,$logStatus) && !array_key_exists($value,$cmdStatus)){
					$cmdText = $text['NPAI.status.cmd.fail']." the id is not exist";
					if($logStatus[$value]['status']=='true'){
						$logText = $text['NPAI.status.log.succ'];
					}else{
						$logText = $text['NPAI.status.log.fail'].$logStatus[$value]['reason'];
					}
				}elseif(!array_key_exists($value,$logStatus) && array_key_exists($value,$cmdStatus)){
					$logText = "NPAI's log interface is error, reason: the id is not exist";
					if($this->_isTimeOut($cmdStatus[$value]['time'])){
						$cmdText = $text['NPAI.status.cmd.timeout'];
					}else{
						$cmdText = $text['NPAI.status.cmd.succ'];
					}
				}else{
					$cmdText = $text['NPAI.status.cmd.fail']." the id is not exist";
					$logText = $text['NPAI.status.log.fail']." the id is not exist";
				}
				if($logText===true && $cmdText===true){
					$status[$key]['img'] = '<img src="/espc/images/'.$connect_img.'" width="65" height="23" alt="connect" style="vertical-align:top;"/>';
				}else{
					$title = $cmdText.'<br>'.$logText;
					$status[$key]['img'] = '<img src="/espc/images/'.$disconnect_img.'" width="65" height="23" alt="connect" title="'.$title.'" style="vertical-align:top;" class="tipBox"/>';
				}
			}
		}

		return $status;
	}
	
	public function rebootNpai(){
		//system('/bin/super killall -9  npaidaemon.py > /dev/null 2>&1',$retv);
		system("/bin/super kill -9 `ps -elf | grep /opt/nsfocus/NPAI/bin/runtime/npaidaemon.py | grep -v grep | awk '{print $4}' | xargs` > /dev/null 2>&1",$retv);
		system("/bin/super kill -9 `ps -elf | grep /opt/nsfocus/NPAI/bin/qpidd/linux/qpidd | grep -v grep | awk '{print $4}' | xargs` > /dev/null 2>&1",$retv);
		return $retv;
	}

	public function restartWebtoid(){
		//system('/bin/super bzypython /opt/nsfocus/bin/devctl2.py -m system_ctl restart_webtoid',$retv);
		system("/bin/super kill -9 `ps -elf | grep /opt/nsfocus/bin/webtoid/webtoid_status.py | grep -v grep | awk '{print $4}' | xargs` > /dev/null 2>&1",$retv);
		system("/bin/super kill -9 `ps -elf | grep /opt/nsfocus/bin/webtoid/webtoid_conf.py | grep -v grep | awk '{print $4}' | xargs` > /dev/null 2>&1",$retv);
		system("/bin/super kill -9 `ps -elf | grep /opt/nsfocus/bin/webtoid/webtoid_asset.py | grep -v grep | awk '{print $4}' | xargs` > /dev/null 2>&1",$retv);		
		return $retv;
	}
	
	public function recoverSetting(){
		$recoverInfo = $this->getRecoverXmlInfo();
		if(!empty($recoverInfo)){
			$client = @simplexml_load_file($this->client_xml);
			foreach($client->broker as $broker){
				$id = (int)$broker['id'];
				$broker->port->tcp = $recoverInfo[$id]['tcp'];
				$broker->port->ssl = $recoverInfo[$id]['ssl'];
				$broker->userid = $recoverInfo[$id]['userid'];
				$broker->passwd = $recoverInfo[$id]['passwd'];
				$broker->transport = $recoverInfo[$id]['transport'];
				$broker->pkey = $recoverInfo[$id]['pkey'];
				$broker->ftp_user = $recoverInfo[$id]['ftp_user'];
				$broker->ftp_pwd = $recoverInfo[$id]['ftp_pwd'];
				$broker->ftp_port = $recoverInfo[$id]['ftp_port'];
				$broker['uploadlog'] = $recoverInfo[$id]['uploadlog'];
			}
			$client->asXML($this->client_xml);
			return "setting.recover.succ";
		}else{
			return "setting.recover.fail";
		}
	}
	
	public function updateNpai($file){
		$updateNpai_path = '/tmp/updateNpai.dat';
		move_uploaded_file($file['tmp_name'],$updateNpai_path);
		if(file_exists($updateNpai_path)){
			$update_cmd = "cd /opt/nsfocus/NPAI/bin/update/ && /bin/super bzypython manu_update.py --file '".$updateNpai_path."'";
			exec($update_cmd,$output,$re);
			if($re==0){
				return true;
			}else{
				return false;
			}
		}else{
			return false;
		}
		
	}

	public function operationLog_Record_Send($msg,$operationType=2,$userName=null){
		$msg = base64_encode($msg);
		$cmdInfo = ' -p '.$_SERVER['REMOTE_ADDR'].' -u '.$this->_getUserName().' -o '.$operationType.' "'.$msg.'"';
		$cmd = '/bin/super bzypython /opt/nsfocus/NPAI/bin/update/sendaudit.py'.$cmdInfo.' 2>&1';
		@exec($cmd,$out,$rev);
	}

	private function _getUserName($userName=null) {
		if ($userName == null) {
			$userName = $_SESSION['login.user']['account']?$_SESSION['login.user']['account']:"";
		}
		return $userName;
	}
	
	
	private function getRecoverXmlInfo(){
		$info = array();
		if(file_exists($this->recover_xml)){
			$dom = @simplexml_load_file($this->recover_xml);
			foreach($dom->broker as $broker){
				$id = (int)$broker['id'];
				$info[$id] = array(
								'tcp'=>(string)$broker->port->tcp,
								'ssl'=>(string)$broker->port->ssl,
								'userid'=>(string)$broker->userid,
								'passwd'=>(string)$broker->passwd,
								'transport'=>(string)$broker->transport,
								'pkey'=>(string)$broker->pkey,
								'ftp_user'=>(string)$broker->ftp_user,
								'ftp_pwd'=>(string)$broker->ftp_pwd,
								'ftp_port'=>(string)$broker->ftp_port,
								'uploadlog'=>(string)$broker['uploadlog'],
							);
			}
			return $info;
		}else{
			return array();
		}
	}
	
	private function getStatusForLog(){
		$xml_path = $this->log_xml;
		if(!file_exists($xml_path)){
			return array();
		}
		$status = array();
		$key = "";
		$dom = @simplexml_load_file($xml_path);
		$time = (int)$dom->time;
		$status['time'] = $time;
		foreach($dom->host as $host){
			$id = trim((string)$host['id']);
			$links = (string)$host['status'];
			$reason = base64_decode((string)$host['lasterr']);
			$status[$id] = array('status'=>$links,'reason'=>$reason);
		}
		return $status;
	}
	
	private function getStatusForCmd(){
		$xml_path = $this->cmd_xml;
		if(!file_exists($xml_path)){
			return array();
		}
		$status = array();
		$key = "";
		$dom = @simplexml_load_file($xml_path);
		foreach($dom->host as $host){
			$id = trim((string)$host['id']);
			$time = (string)$host['time'];
			$status[$id] = array('time'=>$time);
		}
		return $status;
	}
	
	private function getLocalIp(){
		$ip = @file_get_contents($this->local_ip_xml);
		return trim($ip);
	}
	
	private function getCilentInfo(){
		$info = array();
		$dom = @simplexml_load_file($this->client_xml);
		foreach($dom->broker as $broker){
			$id = (string)$broker['id'];
			$auth_pwd = base64_decode((string)$broker->passwd);
			$ftp_pwd = base64_decode((string)$broker->ftp_pwd);
			$aes_pwd = base64_decode((string)$broker->pkey);
			$aes_pwd = trim($aes_pwd);
			if(!empty($aes_pwd)){
				$aes_pwd = substr(MD5($aes_pwd),0,8);
			}
			if($id=='0'){
				$info['espp_ip'] = (string)$broker->host;
				$info['espp_port_ssl'] = (string)$broker->port->ssl;
				$info['espp_port_tcp'] = (string)$broker->port->tcp;
//				$info['espp_auth_name'] = (string)$broker->userid;
//				$info['espp_auth_pwd'] = substr(MD5($auth_pwd),0,8);
				$info['espp_tran'] = (string)$broker->transport;
				$info['espp_aes_pwd'] = $aes_pwd;
				$info['espp_inuse'] = (string)$broker['inuse'];
				$info['espp_log'] = (string)$broker['uploadlog'];
			}else{
				$info['espc_ip_'.$id] = (string)$broker->host;
				$info['espc_port_ssl_'.$id] = (string)$broker->port->ssl;
				$info['espc_port_tcp_'.$id] = (string)$broker->port->tcp;
//				$info['espc_auth_name_'.$id] = (string)$broker->userid;
				$info['espc_auth_pwd_'.$id] = substr(MD5($auth_pwd),0,8);
				$info['espc_tran_'.$id] = (string)$broker->transport;
				$info['espc_aes_pwd_'.$id] = $aes_pwd;
				$info['espc_inuse_'.$id] = (string)$broker['inuse'];
				$ftp_pwd = trim($ftp_pwd);
				if(!empty($ftp_pwd)){
					$ftp_pwd = substr(MD5($ftp_pwd),0,8);
				}
				$info['espc_ftp_pwd_'.$id] = $ftp_pwd;
				$info['espc_ftp_port_'.$id] = (string)$broker->ftp_port;
			}
		}
		return $info;
	}
	
	public function updateNpaiSetting($info){
		if(!$this->editEspp()){
			$info['espp_ip'] = $this->espp_address;
		}
		$this->updateLocalIp($info['local_ip']);
		$this->updateClientXml($info);
	}

	public function editEspp(){
		if(file_exists($this->editespp_path)){
			$content = @file_get_contents($this->editespp_path);
			$content = trim($content);
			if($content=='true'){
				return true;
			}
		}
		return false;
	}
	
	public function getDebugInfo(){
		$cmd = "cd /opt/nsfocus/NPAI/bin/tools && /bin/super bzypython getinfos.py";
		@exec($cmd,$out,$rev);
		return array($rev,trim($out[0]));
	}
	
	public function autoUpdateSetting($value){
		if(file_exists($this->autoUpdate_path)){
			if($value=='true'){
				@file_put_contents($this->autoUpdate_path,'true');
				return 'true';
			}elseif($value=='false'){
				@file_put_contents($this->autoUpdate_path,'false');
				return 'true';
			}else{
				return 'false';
			}
		}else{
			return 'false';
		}
	}

	private function updateLocalIp($ip){
		$ip = trim($ip);
		@file_put_contents($this->local_ip_xml,$ip);
	}
	
	private function updateClientXml($info){
		$dom = @simplexml_load_file($this->client_xml);
		foreach($dom->broker as $broker){
			$id = $broker['id'];
			$passwd = "";
			if($id=='0'){
				$host = $info['espp_ip'];
				$ssl = $info['espp_port_ssl'];
				$tcp = $info['espp_port_tcp'];
//				$uerid = $info['espp_auth_name'];
				$passwd = $info['espp_auth_pwd'];
				$transport = $info['espp_tran'];
				$pkey = $info['espp_aes_pwd'];
				$inuse = $info['espp_inuse'][0]=='yes'?'yes':'no';
				$broker['uploadlog'] = $info['espp_log'][0]=='yes'?'yes':'no';
			}else if($id=='1001')
			{
				continue;
			}
			else{
				$host = $info['espc_ip_'.$id];
				$ssl = $info['espc_port_ssl_'.$id];
				$tcp = $info['espc_port_tcp_'.$id];
//				$uerid = $info['espc_auth_name_'.$id];
				$passwd = $info['espc_auth_pwd_'.$id];
				$transport = $info['espc_tran_'.$id];
				$pkey = $info['espc_aes_pwd_'.$id];
				$ftp_pwd = $info['espc_ftp_pwd_'.$id];
				$ftp_port = $info['espc_ftp_port_'.$id];
				$inuse = $info['espc_inuse_'.$id][0]=='yes'?'yes':'no';
				$old_auth_pwd = base64_decode((string)$broker->passwd);
				if(substr(MD5($old_auth_pwd),0,8)!=$passwd){
					$broker->passwd = base64_encode($passwd);
				}
				$old_aes_pwd = base64_decode((string)$broker->pkey);
				if(substr(MD5($old_aes_pwd),0,8)!=$pkey){
					$broker->pkey = base64_encode($pkey);
				}
			}
			$broker->host = $host;
			$broker->port->ssl = $ssl;
			$broker->port->tcp = $tcp;
//			$broker->userid = $uerid;
			
			$broker->transport = $transport;
			$broker['inuse'] = $inuse;
			$old_ftp_pwd = base64_decode((string)$broker->ftp_pwd);
			if(substr(MD5($old_ftp_pwd),0,8)!=$ftp_pwd){
				$broker->ftp_pwd =  base64_encode($ftp_pwd);
			}
			$broker->ftp_port = $ftp_port;
		}
		$dom->asXML($this->client_xml);
	}
	
	private function _GetClientIds(){
		$info = array();
		$dom = @simplexml_load_file($this->client_xml);
		foreach($dom->broker as $broker){
			$id = (string)$broker['id'];
			$host = trim((string)$broker->host);
			if(!empty($host) && $broker['inuse']=='yes'){
				$info[$id] = $host;
			}
		}
		return $info;
	}
	
	private function _isTimeOut($time){
		$content = @file_get_contents($this->timeout);
		$content = trim($content);
		$content = (int)$content;
		$now = time();
		if(($now-$time)>$content){
			return true;
		}else{
			return false;
		}
	}
	
	private function getNpaiInfo(){
		$info = array();
		if(file_exists($this->npai_version)){
			$dom = @simplexml_load_file($this->npai_version);
			$info['version'] = (string)$dom->version;
			if(!empty($dom->updatetime)){
				$info['updateTime'] = date("Y-m-d H:i:s",(int)$dom->updatetime);
			}else{
				$info['updateTime'] = "";
			}
		}
		if(file_exists($this->autoUpdate_path)){
			$info['autoUpdate'] = @file_get_contents($this->autoUpdate_path);
		}
		return $info;
	}
}
?>