#-*- coding: utf-8 -*-
from django.template.loader import get_template
from django.http import HttpResponse
from django.template import context
from django.shortcuts import render_to_response
from django.http import HttpResponseRedirect
from django.utils.http import urlquote
from django.conf import settings
from npai_conf.npaiSetting import NpaiSetting
from django.utils.translation import get_language
import os,sys
import logging
from django.core.context_processors import csrf
import simplejson
from django.contrib.auth.decorators import login_required
from common.commonUtils import *
from django.utils.translation import ugettext as _
#npai配置的首页

class Logger():
    def __init__(self):
        self.__init_logger()
    
    def __init_logger(self):
        try:
            sys.path.insert(0, '/opt/aurora/www/common/web')
            sys.path.insert(0, '/opt/aurora/www')
            from applog import setConfig
            setConfig()
            self.logger = logging.getLogger('auditLogger')
        except BaseException, e:
            self.logger = None
    
    def __call__(self, request, message, result):
        try:
            account = request.session['account']
            userid = int(request.session['userid'])
            host = request.META['REMOTE_ADDR']
            self.logger.conLog(2, account, userid, host, result, message)
        except BaseException, e:
            pass

logger = Logger()

@login_required
def main(request):
    npaiSetting = NpaiSetting()
    
    localIp = npaiSetting.getLocalIp()
    clientList = npaiSetting.getCilentList()
    
    flag = request.GET.get('flag')
    
    _lang = getLocalLang()
    status = npaiSetting.getNpaiStatus(_lang)
    
    csrf_token = str(csrf(request)['csrf_token'])
    
    versionInfo = npaiSetting.getNpaiInfo()
   
    return render_to_response('main.html',{'localIp':localIp,'clientList':clientList,'alertInfo':flag,'status':status,'csrf_token':csrf_token,'versionInfo':versionInfo})

def getLocalLang():
    _lang = get_language()
    _index = _lang.rfind('-') 
    if _index>-1:
        _lang = _lang[0:_index]+'_'+_lang[_index+1:].upper()
    return _lang


def getStatus(request):
    _lang = getLocalLang()
    npaiSetting = NpaiSetting()
    status = npaiSetting.getNpaiStatus(_lang)
    return HttpResponse(simplejson.dumps(status))


def recoverSetting(request):
    npaiSetting = NpaiSetting()
    status = npaiSetting.recoverSetting()
    detail = npaiSetting.rebootNpai()
    logger(request, _(u'恢复安全中心默认参数'), True)
    return HttpResponseRedirect("/npai_conf/index?flag=recoverSuccess")


def update(request):
    dict = request.POST 
    if not checkSubmit(dict):
        logger(request, _(u'参数类型格式或者类型不正确'), '')
        return HttpResponseRedirect("/npai_conf/index?flag=updateFail")
    npaiSetting = NpaiSetting()
    #npaiSetting.updateClientXml(dict)
    npaiSetting.updateNpaiSetting(dict)
    detail = npaiSetting.rebootNpai()
    print dict
    #print dict
    #flag=setting.update.fail setting.update.succ
    logger(request, _(u'配置安全中心参数'), True)
    return HttpResponseRedirect("/npai_conf/index?flag=updateSuccess")
       
def autoUpdateSetting(request):
    value = request.GET.get('enable')
    npaiSetting = NpaiSetting()
    isSuccess = npaiSetting.autoUpdateSetting(value)
    msg = 'autoUpdateSuccess'
    if  isSuccess==False:
        msg = 'autoUpdateFail'
    action = '开启' if value == 'true' else '关闭'
    logger(request, _(u'%s接口自动升级') % action, isSuccess)
    
    return HttpResponseRedirect("/npai_conf/index?flag=%s"%msg)


def updateNpai(request):
    fileObj = request.FILES['update_npai']
    if check_filename(fileObj.name,'dat') :
        msg = 'updateNpaiFail'
        return HttpResponseRedirect("/npai_conf/index?flag=%s"%msg)
    info = {}
    info['account'] = request.session['account']
    info['userid'] = request.session['userid']
    info['remoteaddr'] = request.META['REMOTE_ADDR']

    npaiSetting = NpaiSetting()
    isSuccess = npaiSetting.updateNpai(fileObj, info)
    
    #接口升级成功,请重启系统服务
    msg = 'updateNpaiSuccess'
    
    if  isSuccess==False:
        #接口升级失败
        msg = 'updateNpaiFail'
    logger(request, _(u'NPAI手动升级'), isSuccess)
        
    return HttpResponseRedirect("/npai_conf/index?flag=%s"%msg)


def getDebugInfo(request):
    npaiSetting = NpaiSetting()
    path = npaiSetting.getDebugInfo()
    if os.path.exists(path):  
        #return downLoads(path)
        f = open(path)
        data = f.read()
        f.close()

        response = HttpResponse(data,mimetype='application/octet-stream') 
        response['Content-Disposition'] = 'attachment; filename=%s' % os.path.basename(path)
        logger(request, _(u'获取调试信息'), True)
        return response
    else:
        logger(request, _(u'获取调试信息'), False)
        return HttpResponseRedirect("/npai_conf/index?flag=getDebugInfoFail")

def reloadModules(request):
    try:
        curpath = os.path.normpath(os.path.dirname(os.path.abspath(__file__)))
        modpath = os.path.normpath(curpath + os.sep + 'reloadmods.json')
        for mod in simplejson.load(open(modpath, 'rb')):
            if mod in sys.modules:
                reload(sys.modules[mod])
            else:
                __import__(mod)
        return HttpResponse('success')
    except BaseException, e:
        return HttpResponse('failure')
        
def checkSubmit(dict) :
    '''校验上传参数'''
    ip = dict.get("localIp") #本地ip
    passwd_1 = dict.get("passwd_1")
    passwd_0 = dict.get("passwd_0")
    ftp_pwd_1 = dict.get("ftp_pwd_1")
    
    ftp_port_1 = dict.get("ftp_port_1")
    ssl_0 = dict.get("ssl_0")
    ssl_1 = dict.get("ssl_1")
    tcp_1 = dict.get("tcp_1")
    tcp_0 = dict.get("tcp_0")
    if ip :
        if validate_ip4(ip) or validate_ip6(ip):
            pass
        else :
            False
    #if passwd_0 :
    #    if check_password(passwd_0) :
    #        return True
    #    else :
    #        return False
    #if passwd_1 :
    #    if check_password(passwd_1) :
    #        return True
    #    else :
    #        return False
    #if ftp_pwd_1 :
    #    if check_password(ftp_pwd_1) :
    #        return True
    #    else :
    #        return False
    
    if ftp_port_1 :
        if check_port(ftp_port_1) :
            pass
        else :
            return False
    if ssl_0 :
        if check_port(ssl_0) :
            pass
        else :
            return False
    if ssl_1 :
        if check_port(ssl_1) :
            pass
        else :
            return False
    if tcp_1 :
        if check_port(tcp_1) :
            pass
        else :
            return False
    if tcp_0 :
        if check_port(tcp_0) :
            pass
        else :
            return False
    return True
