#-*- coding: utf-8 -*-
from django.template.loader import get_template
from django.http import HttpResponse
from django.template import context
from django.shortcuts import render_to_response
from django.http import HttpResponseRedirect
from django.utils.http import urlquote
from django.conf import settings
from npai_conf.npaiSetting import NpaiSetting
from django.utils.translation import get_language
import os,sys
import logging
from django.core.context_processors import csrf
import simplejson
from django.contrib.auth.decorators import login_required
#npai配置的首页

@login_required
def main(request):
    npaiSetting = NpaiSetting()
    
    localIp = npaiSetting.getLocalIp()
    clientList = npaiSetting.getCilentList()
    
    flag = request.GET.get('flag')
    
    _lang = getLocalLang()
    status = npaiSetting.getNpaiStatus(_lang)
    
    csrf_token = str(csrf(request)['csrf_token'])
    
    versionInfo = npaiSetting.getNpaiInfo()
    ff = open('/tmp/xx', 'wb')
    ff.write(str(versionInfo))
    ff.close()
    return render_to_response('main.html',{'localIp':localIp,'clientList':clientList,'alertInfo':flag,'status':status,'csrf_token':csrf_token,'versionInfo':versionInfo})


def getLocalLang():
    _lang = get_language()
    print "language: ", _lang
    #_lang = 'zh_CN'
    _index = _lang.rfind('-') 
    if _index>-1:
        _lang = _lang[0:_index]+'_'+_lang[_index+1:].upper()
    return _lang


def getStatus(request):
    _lang = getLocalLang()
    npaiSetting = NpaiSetting()
    status = npaiSetting.getNpaiStatus(_lang)
    return HttpResponse(
        simplejson.dumps(status, ensure_ascii=False)
        ,content_type='application/json')


def recoverSetting(request):
    npaiSetting = NpaiSetting()
    status = npaiSetting.recoverSetting()
    detail = npaiSetting.rebootNpai()
    return HttpResponseRedirect("/npai_conf/index?flag=recoverSuccess")


def update(request):
    dict = request.POST 
    npaiSetting = NpaiSetting()
    #npaiSetting.updateClientXml(dict)
    npaiSetting.updateNpaiSetting(dict)
    detail = npaiSetting.rebootNpai()
    #print dict
    #flag=setting.update.fail setting.update.succ
    return HttpResponseRedirect("/npai_conf/index?flag=updateSuccess")
       
def autoUpdateSetting(request):
    value = request.GET.get('enable')
    npaiSetting = NpaiSetting()
    isSuccess = npaiSetting.autoUpdateSetting(value)
    msg = 'autoUpdateSuccess'
    if  isSuccess==False:
        msg = 'autoUpdateFail'
    
    return HttpResponseRedirect("/npai_conf/index?flag=%s"%msg)


def updateNpai(request):
    fileObj = request.FILES['update_npai']
    
    info = {}
    info['account'] = request.session['account']
    info['userid'] = request.session['userid']
    info['remoteaddr'] = request.META['REMOTE_ADDR']

    npaiSetting = NpaiSetting()
    isSuccess = npaiSetting.updateNpai(fileObj, info)
    
    #接口升级成功,请重启系统服务
    msg = 'updateNpaiSuccess'
    
    if  isSuccess==False:
        #接口升级失败
        msg = 'updateNpaiFail'
        
    return HttpResponseRedirect("/npai_conf/index?flag=%s"%msg)


def getDebugInfo(request):
    npaiSetting = NpaiSetting()
    path = npaiSetting.getDebugInfo()
    if os.path.exists(path):  
        #return downLoads(path)
        f = open(path)
        data = f.read()
        f.close()

        response = HttpResponse(data,mimetype='application/octet-stream') 
        response['Content-Disposition'] = 'attachment; filename=%s' % os.path.basename(path)
        return response
    else:
        return HttpResponseRedirect("/npai_conf/index?flag=getDebugInfoFail")

